#
# Conditional build:
%bcond_without	apidocs		# do not build and package API docs

Summary:	Kinetic C++ client library
Summary(pl.UTF-8):	Biblioteka kliencka C++ Kinetic
Name:		kinetic-cpp-client
Version:	0.1.1
Release:	5
License:	GPL v2+
Group:		Libraries
Source0:	https://github.com/Kinetic/kinetic-cpp-client/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	ac77cc4ebf388e0e1d690317888373e6
Patch0:		%{name}-system-libs.patch
Patch1:		%{name}-openssl.patch
Patch2:		%{name}-protocol.patch
URL:		https://github.com/Kinetic/kinetic-cpp-client/
BuildRequires:	cmake >= 2.8.6
%{?with_apidocs:BuildRequires:	doxygen}
BuildRequires:	gflags-devel >= 2.0
BuildRequires:	glog-devel >= 0.3.3
BuildRequires:	gmock-devel >= 1.10.0
BuildRequires:	gtest-devel >= 1.6.0
BuildRequires:	kinetic-protocol >= 4.0
BuildRequires:	libstdc++-devel
BuildRequires:	openssl-devel >= 1.0.1g
BuildRequires:	protobuf-devel >= 2.5.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This package contains a library for producing Kinetic C++ clients for
interacting with Kinetic object-based storage.

%description -l pl.UTF-8
Ten pakiet zawiera bibliotekę do tworzenia w języku C++ klientów
Kinetic mających współpracować z opartym na obiektach systemem
przechowywania danych Kinetic.

%package devel
Summary:	Header files for Kinetic C++ client library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki klienckiej C++ Kinetic
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libstdc++-devel
Requires:	openssl-devel
%requires_ge	protobuf-devel

%description devel
Header files for Kinetic C++ client library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki klienckiej C++ Kinetic.

%package apidocs
Summary:	Kinetic C++ client API documentation
Summary(pl.UTF-8):	Dokumentacja API biblioteki klienckiej C++ Kinetic
Group:		Documentation
%if "%{_rpmversion}" >= "4.6"
BuildArch:	noarch
%endif

%description apidocs
API documentation for Kinetic C++ client library.

%description apidocs -l pl.UTF-8
Dokumentacja API biblioteki klienckiej C++ Kinetic.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
install -d build
cd build
%cmake ..

%{__make}

%{?with_apidocs:%{__make} doc}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_includedir},%{_libdir}}

install build/libkinetic_client.so $RPM_BUILD_ROOT%{_libdir}
cp -pr include/kinetic $RPM_BUILD_ROOT%{_includedir}
cp -p src/main/generated/kinetic_client.pb.h $RPM_BUILD_ROOT%{_includedir}/kinetic

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc README.md
%attr(755,root,root) %{_libdir}/libkinetic_client.so

%files devel
%defattr(644,root,root,755)
%{_includedir}/kinetic

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%doc docs/*.{css,html,js,png}
%endif
%changelog
* Sat May 23 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/kinetic-cpp-client.git;a=log;h=master

* Fri May 22 2020 Jakub Bogusz <qboosh@pld-linux.org> 5f5e703
- switched tests to system gmock-devel (as packaged since 1.10.0)

* Fri May 22 2020 Jakub Bogusz <qboosh@pld-linux.org> b948d43
- added openssl patch (fix for openssl 1.1+)
- added protocol patch (adjust for kinetic-protocol 4)
- release 5 (rebuild with kinetic-protocol 4 and protobuf 3.11.x)

* Mon Apr 11 2016 Jakub Bogusz <qboosh@pld-linux.org> 7163ac4
- updated URLs

* Mon Mar 30 2015 Elan Ruusamäe <glen@delfi.ee> 7a1f72d
- x32 rebuild
- release 4 (by relup.sh)

* Sun Mar 29 2015 Elan Ruusamäe <glen@delfi.ee> 39222be
- noarch apidocs

* Mon Feb 09 2015 Jakub Bogusz <qboosh@pld-linux.org> 27dcb35
- updated system-libs patch to support current gflags (with gflags:: ns instead of google::)
- install missing autogenerated header (kinetic_client.pb.h)
- release 2

* Sat Oct 18 2014 Jakub Bogusz <qboosh@pld-linux.org> 92b8d7f
- new; patched to use system libs

